# AntiKill
# When a player dies by fall damage, or by any other non-player method
# the last player to damage them gets the kill!

import es

global player_array
player_array = {}

def load():
    es.set('anti_kill_ver',1)
    es.makepublic("anti_kill_ver")
    es.set('__temp_userid',0)
    es.set('__temp_attacker',0)
    cmd('est_RegEventBlock player_death "es_xdoblock antikill/pre_death"')
    for userid in es.getUseridList():
        player_array[userid] = 0
    
def unload():
    cmd('est_UnRegEventBlock player_death "es_xdoblock antikill/pre_death"')    

def player_hurt(ev):
    global player_array
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    if attacker:
        # If the attacker is not 0, or in other words not the world
        player_array[userid] = attacker

def pre_death():
    global player_array
    cmd('est_GetEventInfo __temp_userid userid')
    cmd('est_GetEventInfo __temp_attacker attacker')
    attacker = int(es.ServerVar('__temp_attacker'))
    userid = es.getInt('__temp_userid')
    if attacker == 0 or attacker == userid:
        # if no one killed him, we grab his last attacker from the array
        last_attack = player_array[userid]
        if last_attack:
            # If someone did atually attack himer
            # We check if they exist on the server
            if es.exists('userid',last_attack):
                cmd('est_SetEventInfo attacker %s'%last_attack)
                cmd('est_seteventinfo weapon anti_kill')

def player_death(ev):
    global player_array
    player_array[int(ev['userid'])] = 0

def player_connect(ev):
    global player_array
    player_array[int(ev['userid'])] = 0

def player_disconnect(ev):
    global player_array
    del player_array[int(ev['userid'])]

def cmd(args):
    # I don't like using es.Servercommand, so i made this wrapper
    es.ForceServerCommand(args)
